/************************************************************
Copyright (C), 1988-1999, Tech. Co., Ltd.
FileName: 
Author: 
Version : 
Date:
Description:
Version: 
Function List: 
1. -------
History: 
<author> <time> <version > <desc>
David 96/10/12 1.0 build this moudle 
***********************************************************/

#include <stdio.h>
#include "touch_xpt2046.h"
#include "GUI.h"
/*
1STM32-X2 + 3.0ʾģ飬 ʾģϵĴоƬΪ TSC2046оƬ
	PA8   --> TP_CS
	PD3   --> TP_BUSY
	PA5   --> TP_SCK
	PA6   --> TP_MISO
	PA7   --> TP_MOSI
	PC7   --> TP_PEN_INT

2STM32 + 4.37ʾģ飨RA8875оƬ)
	RA8875ôӿڣֱͨFSMCRA8875ؼĴɡ

	2У׼У׼󱣴2У׼ADCֵʵʹʱ2ֱ߷̼Ļꡣ
	У׼бӿڣҪʾδ湦ܡ
	ҿԼ޸  TOUCH_SaveParam()  TOUCH_LoadParam() ʵֱ湦ܡ

*/

/* TSC2046 Ƭѡ */
#define	SPI_TOUCH_CS PBout(12)  //ѡ
#define TOUCH_PressValid    GPIO_ReadInputDataBit(GPIOG, GPIO_Pin_7)

/* TSC2046 ڲADCͨ */
#define ADC_CH_X	5		/* XͨXλ */
#define ADC_CH_Y	1		/* YͨYλ */


/* ģõȫֱ */
TOUCH_T g_tTP;
TOUCHSL_T g_tTPSL;

static void TSC2046_InitHard(void);
uint16_t TSC2046_ReadAdc(uint8_t _ucCh);
void TOUCH_LoadParam(void);
void TOUCH_SaveParam(void);
int32_t TOUCH_Abs(int32_t x);

/*
*********************************************************************************************************
*	  : bsp_InitTouch
*	˵: STM32ʹصĿߣʹӲSPI1, Ƭѡ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void TOUCH_InitHard(void)
{	
	GPIO_InitTypeDef  GPIO_InitStructure;
	 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOG, ENABLE);
	
	/*  PC7 Ϊģʽڴж */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOG, &GPIO_InitStructure);
	
	TSC2046_InitHard();
}

/*
*********************************************************************************************************
*	  : TOUCH_DataFilter
*	˵: ȡһֵ(xy)
*             ȡXPT2046_READ_TIMES,Щ,
*             ȻȥͺXPT2046_LOST_VAL,ȡƽֵ 
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
/* ȡ */
#define XPT2046_READ_TIMES    5 
/* ֵ  */	
#define XPT2046_LOST_VAL      1	  	
uint16_t TOUCH_DataFilter(uint8_t _ucCh)
{
	uint16_t i, j;
	uint16_t buf[XPT2046_READ_TIMES];
	uint16_t usSum;
	uint16_t usTemp;

	/* ȡREAD_TIMES*/
	for(i=0; i < XPT2046_READ_TIMES; i++)
	{
			buf[i] = TSC2046_ReadAdc(_ucCh);	
	}
	
	/*  */		 		    
	for(i = 0; i < XPT2046_READ_TIMES - 1; i++)
	{
		for(j = i + 1; j < XPT2046_READ_TIMES; j++)
		{
			if(buf[i] > buf[j])
			{
				usTemp = buf[i];
				buf[i] = buf[j];
				buf[j] = usTemp;
			}
		}
	}
		  
	usSum = 0;

	/* */
	for(i = XPT2046_LOST_VAL; i < XPT2046_READ_TIMES - XPT2046_LOST_VAL; i++)
	{
		usSum += buf[i];
	}
	/*ƽ */
	usTemp = usSum / (XPT2046_READ_TIMES - 2 * XPT2046_LOST_VAL);

	return usTemp; 
} 

/*
*********************************************************************************************************
*	  : TOUCH_ReadAdcXY
*	˵: 2ζȡIC,εƫܳ
*             ADC_ERR_RANGE,,Ϊȷ,.	   
*             úܴ׼ȷ
*	    Σx,y:ȡֵ
*	  ֵ: 0,ʧ;1,ɹ
*********************************************************************************************************
*/
/* Χ */  
uint8_t ADC_ERR_RANGE = 5; 
uint8_t TOUCH_ReadAdcXY(int16_t *_usX, int16_t *_usY) 
{
	uint16_t iX1, iY1;
 	uint16_t iX2, iY2;
	uint16_t iX, iY;

 	iX1 = TOUCH_DataFilter(ADC_CH_X);
	iY1 = TOUCH_DataFilter(ADC_CH_Y);
	iX2 = TOUCH_DataFilter(ADC_CH_X);
	iY2 = TOUCH_DataFilter(ADC_CH_Y);
	
	iX = TOUCH_Abs(iX1 - iX2);
	iY = TOUCH_Abs(iY1 - iY2); 
	
	/* ǰβ+-ERR_RANGE */  
    if ((iX <= ADC_ERR_RANGE) && (iY <= ADC_ERR_RANGE))
    {       	
		*_usX = (iX1 + iX2) / 2;
		*_usY = (iY1 + iY2) / 2;	

		return 1;
    }
	else 
	{
		return 0;
	}	  
} 

/*
*********************************************************************************************************
*	  : TOUCH_Scan
*	˵: ¼򡣸úԵãÿms1.  bsp_Timer.c
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void TOUCH_SCAN(void)
{
	uint8_t s_invalid_count = 0;
	GUI_PID_STATE State;
	
	if(TOUCH_PressValid == 0)
	{			

		while(!TOUCH_ReadAdcXY(&g_tTP.usAdcNowX, &g_tTP.usAdcNowY)&&s_invalid_count < 20);
		{
			s_invalid_count++;
		}
		if(s_invalid_count >= 20)
		{
			g_tTP.usAdcNowX = -1;
			g_tTP.usAdcNowY = -1;	
			
			State.x = g_tTP.usAdcNowX;
			State.y = g_tTP.usAdcNowY;
			State.Pressed = 0;
			GUI_TOUCH_StoreStateEx(&State);	
		}
		
		State.x = g_tTP.usAdcNowX;
		State.y = g_tTP.usAdcNowY;
		State.Pressed = 1;
		GUI_TOUCH_StoreStateEx(&State);
		
	}
	else
	{
		g_tTP.usAdcNowX = -1;
		g_tTP.usAdcNowY = -1;	
		
		State.x = g_tTP.usAdcNowX;
		State.y = g_tTP.usAdcNowY;
		State.Pressed = 0;
		GUI_TOUCH_StoreStateEx(&State);		
	}
			
}

/*
*********************************************************************************************************
*	  : bsp_InitTouch
*	˵: STM32ʹصĿߣʹӲSPI1, Ƭѡ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
static void TSC2046_InitHard(void)
{


	GPIO_InitTypeDef  GPIO_InitStructure;
	SPI_InitTypeDef   SPI_InitStructure;

	/* GPIOʱ */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB , ENABLE);
	
	/*  SPI2 ʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);

	//Ƭѡź
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_12;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure); 	
	/*  PB12 Ϊ TP_CS  */
	GPIO_SetBits(GPIOB, GPIO_Pin_12);
	
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure); 
	GPIO_SetBits(GPIOB, GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15); 

	SPI_I2S_DeInit(SPI2);
	SPI_I2S_ClearFlag(SPI2, SPI_I2S_FLAG_TXE | SPI_I2S_FLAG_RXNE);	

	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master; 
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b; 
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge; 
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft; 
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256; 
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB; 
	SPI_InitStructure.SPI_CRCPolynomial = 7; 
	SPI_Init(SPI2, &SPI_InitStructure); 
	
	SPI_Cmd(SPI2, ENABLE); 


}

/*
*********************************************************************************************************
*	  : SPI_ShiftByte
*	˵: SPI߷һֽڣͬʱؽյֽ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
static uint8_t SPI_ShiftByte(uint8_t _ucByte)
{
	uint8_t ucRxByte;

	/* ȴͻ */
	while(SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET);

	/* һֽ */
	SPI_I2S_SendData(SPI2, _ucByte);

	/* ȴݽ */
	while(SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET);

	/* ȡյ */
	ucRxByte = SPI_I2S_ReceiveData(SPI2);

	/* ض */
	return ucRxByte;
}

/*
*********************************************************************************************************
*	  : SpiDelay
*	˵: SPI߷һֽڣͬʱؽյֽ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void SpiDelay(uint32_t DelayCnt)
{
	uint32_t i;

	for(i=0;i<DelayCnt;i++);
}

/*
*********************************************************************************************************
*	  : TSC2046_ReadAdc
*	˵: ѡһģͨADCADC
*	    Σ_ucCh = 0 ʾXͨ 1ʾYͨ
*	  ֵ: 12λADCֵ
*********************************************************************************************************
*/
uint16_t TSC2046_ReadAdc(uint8_t _ucCh)
{
	uint16_t usAdc;

	SPI_TOUCH_CS = 0;

	/*
		TSC2046 ֣8Bit
		Bit7   = S     ʼλ1
		Bit6:4 = A2-A0 ģͨѡA2-A0; 6ͨ
		Bit3   = MODE  ADCλѡ0 ʾ12Bit;1ʾ8Bit
		Bit2   = SER/DFR ģʽ  1ʾ룻0ʾ
		Bit1:0 = PD1-PD0 ģʽѡλ
	*/
	SPI_ShiftByte((1 << 7) | (_ucCh << 4));			/* ѡͨ1, Xλ */

	/* ADC, 12λADCֵĸλȴǰ12bitЧ4bit0 */
	usAdc = SPI_ShiftByte(0x00);		/* ͵0x00Ϊֵ */
	usAdc <<= 8;
	usAdc += SPI_ShiftByte(0x00);		/* 12λADCֵ */

	usAdc >>= 3;						/* 3λ12λЧ */

	SPI_TOUCH_CS = 1;

	return (usAdc);
}



/*
*********************************************************************************************************
*	  : TOUCH_Abs
*	˵: ֵ
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
int32_t TOUCH_Abs(int32_t x)
{
	if (x >= 0)
	{
		return x;
	}
	else
	{
		return -x;
	}
}


/*
*********************************************************************************************************
*	  : TOUCH_SaveParam
*	˵: У׼	s_usAdcX1 s_usAdcX2 s_usAdcY1 s_usAdcX2
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void TOUCH_SaveParam(void)
{
#if 0
	/* 4 */
	uint16_t usBuf[5];

	usBuf[0] = g_tTP.usAdcX1;
	usBuf[1] = g_tTP.usAdcY1;

	usBuf[2] = g_tTP.usAdcX2;
	usBuf[3] = g_tTP.usAdcY2;

	usBuf[4] = g_tTP.XYChange;

#endif
}

/*
*********************************************************************************************************
*	  : TOUCH_LoadParam
*	˵: ȡУ׼
*	    Σ
*	  ֵ: 
*********************************************************************************************************
*/
void TOUCH_LoadParam(void)
{
#if 0
	/* 5 */
	uint16_t usBuf[5];

	/* ReadParamToBuf() */

	g_tTP.usAdcX1 = usBuf[0];
	g_tTP.usAdcY1 = usBuf[1];

	g_tTP.usAdcX2 = usBuf[2];
	g_tTP.usAdcY2 = usBuf[3];


	g_tTP.XYChange = usBuf[4];
#endif
}

/*****************************  www.armfly.com (END OF FILE) *********************************/




